/*
 * Intel ACPI Component Architecture
 * AML Disassembler version 20100528
 *
 * Disassembly of SSDT2.dat, Wed Nov 23 19:57:12 2011
 *
 *
 * Original Table Header:
 *     Signature        "SSDT"
 *     Length           0x00000B8A (2954)
 *     Revision         0x01
 *     Checksum         0x7B
 *     OEM ID           "NvORef"
 *     OEM Table ID     "NvOptTbl"
 *     OEM Revision     0x00001000 (4096)
 *     Compiler ID      "INTL"
 *     Compiler Version 0x20061109 (537268489)
 */
DefinitionBlock ("SSDT2.aml", "SSDT", 1, "NvORef", "NvOptTbl", 0x00001000)
{
    External (CPUD)
    External (CPUV)
    External (NVHA, MethodObj)    // 1 Arguments
    External (P8XH, MethodObj)    // 2 Arguments
    External (\_SB_.PCI0.PEG0, DeviceObj)
    External (\_SB_.PCI0.GFX0, DeviceObj)
    External (\_SB_.PCI0.PEG0.PEGP, DeviceObj)
    External (\_SB_.PCI0.PEG0.PEGP._ADR)

    Scope (\_SB.PCI0.GFX0)
    {
    }

    Scope (\_SB.PCI0.PEG0)
    {
        OperationRegion (RPCI, SystemMemory, 0xF8008000, 0x1000)
        Field (RPCI, DWordAcc, Lock, Preserve)
        {
                    Offset (0xB0), 
            ASPM,   2, 
                ,   2, 
            LNKD,   1, 
                    Offset (0x214), 
                    Offset (0x216), 
            LNKS,   4, 
                    Offset (0x224), 
                    Offset (0x225), 
            DQDA,   1, 
                    Offset (0xC28), 
            HCLQ,   1, 
                    Offset (0xC34), 
                ,   30, 
            PEDQ,   1, 
            PIDQ,   1, 
                    Offset (0xDFC), 
            PEPO,   3, 
                    Offset (0xE08), 
                ,   31, 
            ROE0,   1, 
                    Offset (0xE28), 
                ,   31, 
            ROE1,   1, 
                    Offset (0xE48), 
                ,   31, 
            ROE2,   1, 
                    Offset (0xE68), 
                ,   31, 
            ROE3,   1, 
                    Offset (0xE88), 
                ,   31, 
            ROE4,   1, 
                    Offset (0xEA8), 
                ,   31, 
            ROE5,   1, 
                    Offset (0xEC8), 
                ,   31, 
            ROE6,   1, 
                    Offset (0xEE8), 
                ,   31, 
            ROE7,   1, 
                    Offset (0xF08), 
                ,   31, 
            ROE8,   1, 
                    Offset (0xF28), 
                ,   31, 
            ROE9,   1, 
                    Offset (0xF48), 
                ,   31, 
            ROEA,   1, 
                    Offset (0xF68), 
                ,   31, 
            ROEB,   1, 
                    Offset (0xF88), 
                ,   31, 
            ROEC,   1, 
                    Offset (0xFA8), 
                ,   31, 
            ROED,   1, 
                    Offset (0xFC8), 
                ,   31, 
            ROEE,   1, 
                    Offset (0xFE8), 
                ,   31, 
            ROEF,   1
        }

        OperationRegion (DMIB, SystemMemory, 0xFED18000, 0x1000)
        Field (DMIB, DWordAcc, Lock, Preserve)
        {
                    Offset (0xC34), 
            LLGE,   1, 
                ,   28, 
            PCGE,   1, 
                ,   1, 
            LGGE,   1
        }
    }

    Scope (\_SB.PCI0.PEG0.PEGP)
    {
        OperationRegion (PCIS, SystemMemory, 0xF8100000, 0x0500)
        Field (PCIS, ByteAcc, Lock, Preserve)
        {
            SVID,   32, 
            NCMD,   8, 
            BDAT,   2000
        }

        OperationRegion (GPIO, SystemIO, 0x0500, 0x60)
        Field (GPIO, ByteAcc, Lock, Preserve)
        {
                    Offset (0x0C), 
                ,   3, 
                ,   1, 
                    Offset (0x0E), 
            DGRS,   1, 
            DGPG,   1, 
                    Offset (0x38), 
                ,   3, 
            DGVN,   1, 
            DGPW,   1, 
            DGSP,   1
        }

        Name (BKAL, Buffer (0xFA)
        {
            0x00
        })
        Method (NBAK, 0, NotSerialized)
        {
            Store (BDAT, BKAL)
        }

        Method (NRST, 0, NotSerialized)
        {
            Store (Zero, NCMD)
            Store (BKAL, BDAT)
            Store (0x06, NCMD)
        }

        Method (_INI, 0, NotSerialized)
        {
            Store (Zero, \_SB.PCI0.PEG0.PEGP._ADR)
        }

        Method (_ON, 0, Serialized)
        {
            Store (Zero, DGRS)
            Sleep (0x64)
            Store (One, DGPW)
            Sleep (0x64)
            Store (One, DGVN)
            Sleep (0x64)
            Store (One, DGRS)
            Sleep (0x64)
            While (LNotEqual (\_SB.PCI0.PEG0.PEGP.DGPG, One))
            {
                P8XH (Zero, 0x22)
                Sleep (One)
            }

            If (LEqual (DGPG, One))
            {
                P8XH (Zero, 0x21)
            }

            Sleep (0x64)
            Store (Zero, LNKD)
            Sleep (0x64)
            While (LLess (LNKS, 0x07))
            {
                Sleep (One)
            }

            Sleep (0x64)
            NRST ()
        }

        Method (_OFF, 0, Serialized)
        {
            NBAK ()
            Store (One, LNKD)
            Sleep (0x64)
            While (LNotEqual (LNKS, Zero))
            {
                Sleep (One)
            }

            Sleep (0x64)
            Store (Zero, DGRS)
            Sleep (0x64)
            Store (Zero, DGPW)
            Store (Zero, DGVN)
            Sleep (0x64)
            If (LEqual (DGPG, Zero))
            {
                P8XH (Zero, 0x31)
            }
        }
    }

    Scope (\_SB.PCI0)
    {
        Name (OTM, "OTMACPI 2010-Mar-09 12:08:26")
    }

    Scope (\_SB.PCI0.PEG0.PEGP)
    {
        OperationRegion (NVHM, SystemMemory, NVHA (0x00010400), Field (NVHM, AnyAcc, NoLock, Preserve)
            {
                NVSG,   128, 
                NVSZ,   32, 
                NVVR,   32, 
                        Offset (0x100), 
                NVHO,   32, 
                RVBS,   32, 
                        Offset (0x180), 
                TNDI,   8, 
                DGND,   8, 
                IGND,   8, 
                        Offset (0x190), 
                        Offset (0x1B0), 
                DDI1,   32, 
                DDI2,   32, 
                DDI3,   32, 
                DDI4,   32, 
                DDI5,   32, 
                DDI6,   32, 
                DDI7,   32, 
                DDI8,   32, 
                        Offset (0x200), 
                        Offset (0x220), 
                        Offset (0x240), 
                        Offset (0x260), 
                DCP1,   32, 
                DCP2,   32, 
                DCP3,   32, 
                DCP4,   32, 
                DCP5,   32, 
                DCP6,   32, 
                DCP7,   32, 
                DCP8,   32, 
                DCA1,   32, 
                DCA2,   32, 
                DCA3,   32, 
                DCA4,   32, 
                DCA5,   32, 
                DCA6,   32, 
                DCA7,   32, 
                DCA8,   32, 
                DNA1,   32, 
                DNA2,   32, 
                DNA3,   32, 
                DNA4,   32, 
                DNA5,   32, 
                DNA6,   32, 
                DNA7,   32, 
                DNA8,   32, 
                        Offset (0x3C0), 
                RAPM,   8, 
                EAPM,   8, 
                TSLC,   16, 
                DNDI,   8, 
                        Offset (0x400), 
                RBF1,   262144, 
                RBF2,   262144
            })
    }

    Scope (\_SB.PCI0)
    {
        OperationRegion (RTCO, SystemIO, 0x72, 0x02)
        Field (RTCO, ByteAcc, NoLock, Preserve)
        {
            CIND,   8, 
            CDAT,   8
        }

        IndexField (CIND, CDAT, ByteAcc, NoLock, Preserve)
        {
                    Offset (0x70), 
            OPTF,   1
        }
    }

    Scope (\_SB.PCI0.PEG0.PEGP)
    {
        Method (_ROM, 2, NotSerialized)
        {
            Store (Arg0, Local0)
            Store (Arg1, Local1)
            If (LGreater (Local1, 0x1000))
            {
                Store (0x1000, Local1)
            }

            If (LGreater (Local0, 0x00010000))
            {
                Return (Buffer (Local1)
                {
                    0x00
                })
            }

            If (LGreater (Local0, RVBS))
            {
                Return (Buffer (Local1)
                {
                    0x00
                })
            }

            Multiply (Local1, 0x08, Local3)
            Name (ROM1, Buffer (0x8000)
            {
                0x00
            })
            Name (ROM2, Buffer (Local1)
            {
                0x00
            })
            If (LLess (Local0, 0x8000))
            {
                Store (RBF1, ROM1)
            }
            Else
            {
                Subtract (Local0, 0x8000, Local0)
                Store (RBF2, ROM1)
            }

            Multiply (Local0, 0x08, Local2)
            CreateField (ROM1, Local2, Local3, TMPB)
            Store (TMPB, ROM2)
            Return (ROM2)
        }
    }

    Scope (\_SB.PCI0.PEG0.PEGP)
    {
        Method (GOBT, 1, NotSerialized)
        {
            Name (OPVK, Buffer (0xE6)
            {
                /* 0000 */    0x6D, 0xBC, 0x22, 0x9A, 0x43, 0xDC, 0xF3, 0x3D, 
                /* 0008 */    0x4B, 0x56, 0xE6, 0x00, 0x00, 0x00, 0x01, 0x00, 
                /* 0010 */    0x31, 0x34, 0x38, 0x35, 0x39, 0x37, 0x34, 0x35, 
                /* 0018 */    0x36, 0x39, 0x38, 0x35, 0x47, 0x65, 0x6E, 0x75, 
                /* 0020 */    0x69, 0x6E, 0x65, 0x20, 0x4E, 0x56, 0x49, 0x44, 
                /* 0028 */    0x49, 0x41, 0x20, 0x43, 0x65, 0x72, 0x74, 0x69, 
                /* 0030 */    0x66, 0x69, 0x65, 0x64, 0x20, 0x4F, 0x70, 0x74, 
                /* 0038 */    0x69, 0x6D, 0x75, 0x73, 0x20, 0x52, 0x65, 0x61, 
                /* 0040 */    0x64, 0x79, 0x20, 0x4D, 0x6F, 0x74, 0x68, 0x65, 
                /* 0048 */    0x72, 0x62, 0x6F, 0x61, 0x72, 0x64, 0x20, 0x66, 
                /* 0050 */    0x6F, 0x72, 0x20, 0x37, 0x37, 0x33, 0x38, 0x33, 
                /* 0058 */    0x36, 0x62, 0x5F, 0x32, 0x33, 0x31, 0x30, 0x63, 
                /* 0060 */    0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 
                /* 0068 */    0x2D, 0x20, 0x34, 0x3C, 0x5F, 0x29, 0x40, 0x51, 
                /* 0070 */    0x5F, 0x2F, 0x59, 0x28, 0x24, 0x5D, 0x41, 0x59, 
                /* 0078 */    0x55, 0x2F, 0x32, 0x52, 0x5E, 0x21, 0x41, 0x4B, 
                /* 0080 */    0x5E, 0x23, 0x59, 0x5E, 0x2B, 0x55, 0x42, 0x32, 
                /* 0088 */    0x57, 0x53, 0x3D, 0x4C, 0x2D, 0x4A, 0x42, 0x55, 
                /* 0090 */    0x29, 0x3E, 0x59, 0x35, 0x26, 0x41, 0x5F, 0x2F, 
                /* 0098 */    0x38, 0x45, 0x36, 0x3F, 0x54, 0x45, 0x20, 0x2D, 
                /* 00A0 */    0x20, 0x43, 0x6F, 0x70, 0x79, 0x72, 0x69, 0x67, 
                /* 00A8 */    0x68, 0x74, 0x20, 0x32, 0x30, 0x31, 0x30, 0x20, 
                /* 00B0 */    0x4E, 0x56, 0x49, 0x44, 0x49, 0x41, 0x20, 0x43, 
                /* 00B8 */    0x6F, 0x72, 0x70, 0x6F, 0x72, 0x61, 0x74, 0x69, 
                /* 00C0 */    0x6F, 0x6E, 0x20, 0x41, 0x6C, 0x6C, 0x20, 0x52, 
                /* 00C8 */    0x69, 0x67, 0x68, 0x74, 0x73, 0x20, 0x52, 0x65, 
                /* 00D0 */    0x73, 0x65, 0x72, 0x76, 0x65, 0x64, 0x2D, 0x31, 
                /* 00D8 */    0x34, 0x38, 0x35, 0x39, 0x37, 0x34, 0x35, 0x36, 
                /* 00E0 */    0x39, 0x38, 0x35, 0x28, 0x52, 0x29
            })
            Name (OPV2, Buffer (0xE6)
            {
                /* 0000 */    0xFD, 0xA7, 0x1A, 0x84, 0x0E, 0xC9, 0x98, 0x8A, 
                /* 0008 */    0x4B, 0x56, 0xE6, 0x00, 0x00, 0x00, 0x01, 0x00, 
                /* 0010 */    0x31, 0x34, 0x38, 0x35, 0x39, 0x37, 0x34, 0x35, 
                /* 0018 */    0x36, 0x39, 0x38, 0x35, 0x47, 0x65, 0x6E, 0x75, 
                /* 0020 */    0x69, 0x6E, 0x65, 0x20, 0x4E, 0x56, 0x49, 0x44, 
                /* 0028 */    0x49, 0x41, 0x20, 0x43, 0x65, 0x72, 0x74, 0x69, 
                /* 0030 */    0x66, 0x69, 0x65, 0x64, 0x20, 0x4F, 0x70, 0x74, 
                /* 0038 */    0x69, 0x6D, 0x75, 0x73, 0x20, 0x52, 0x65, 0x61, 
                /* 0040 */    0x64, 0x79, 0x20, 0x4D, 0x6F, 0x74, 0x68, 0x65, 
                /* 0048 */    0x72, 0x62, 0x6F, 0x61, 0x72, 0x64, 0x20, 0x66, 
                /* 0050 */    0x6F, 0x72, 0x20, 0x37, 0x37, 0x33, 0x38, 0x33, 
                /* 0058 */    0x36, 0x62, 0x5F, 0x32, 0x36, 0x32, 0x30, 0x63, 
                /* 0060 */    0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 
                /* 0068 */    0x2D, 0x20, 0x28, 0x20, 0x53, 0x55, 0x44, 0x55, 
                /* 0070 */    0x43, 0x2B, 0x5D, 0x2C, 0x28, 0x59, 0x45, 0x45, 
                /* 0078 */    0x51, 0x2B, 0x36, 0x56, 0x52, 0x2D, 0x45, 0x4F, 
                /* 0080 */    0x41, 0x2F, 0x5D, 0x42, 0x2F, 0x51, 0x46, 0x3E, 
                /* 0088 */    0x53, 0x57, 0x21, 0x31, 0x29, 0x56, 0x46, 0x51, 
                /* 0090 */    0x35, 0x3A, 0x5D, 0x39, 0x2A, 0x4D, 0x43, 0x2B, 
                /* 0098 */    0x24, 0x49, 0x3A, 0x23, 0x58, 0x41, 0x20, 0x2D, 
                /* 00A0 */    0x20, 0x43, 0x6F, 0x70, 0x79, 0x72, 0x69, 0x67, 
                /* 00A8 */    0x68, 0x74, 0x20, 0x32, 0x30, 0x31, 0x30, 0x20, 
                /* 00B0 */    0x4E, 0x56, 0x49, 0x44, 0x49, 0x41, 0x20, 0x43, 
                /* 00B8 */    0x6F, 0x72, 0x70, 0x6F, 0x72, 0x61, 0x74, 0x69, 
                /* 00C0 */    0x6F, 0x6E, 0x20, 0x41, 0x6C, 0x6C, 0x20, 0x52, 
                /* 00C8 */    0x69, 0x67, 0x68, 0x74, 0x73, 0x20, 0x52, 0x65, 
                /* 00D0 */    0x73, 0x65, 0x72, 0x76, 0x65, 0x64, 0x2D, 0x31, 
                /* 00D8 */    0x34, 0x38, 0x35, 0x39, 0x37, 0x34, 0x35, 0x36, 
                /* 00E0 */    0x39, 0x38, 0x35, 0x28, 0x52, 0x29
            })
            CreateWordField (Arg0, 0x02, USRG)
            If (LEqual (USRG, 0x564B))
            {
                If (LEqual (CPUV, 0x8086))
                {
                    If (LEqual (CPUD, 0x0126))
                    {
                        Return (OPV2)
                    }
                    Else
                    {
                        If (LEqual (CPUD, 0x0116))
                        {
                            Return (OPVK)
                        }
                        Else
                        {
                            Return (OPV2)
                        }
                    }
                }

                Return (Zero)
            }
        }
    }

    Scope (\_SB.PCI0.PEG0.PEGP)
    {
        Name (OMPR, 0x02)
        Method (NVOP, 4, NotSerialized)
        {
            Name (_T_0, Zero)
            P8XH (Zero, 0x09)
            Store ("------- NV OPTIMUS DSM --------", Debug)
            If (LNotEqual (Arg1, 0x0100))
            {
                Return (0x80000001)
            }

            Store (ToInteger (Arg2), _T_0)
            If (LEqual (_T_0, Zero))
            {
                Store (Buffer (0x04)
                    {
                        0x00, 0x00, 0x00, 0x00
                    }, Local0)
                Divide (Zero, 0x08, Local2, Local1)
                ShiftLeft (One, Local2, Local2)
                Or (DerefOf (Index (Local0, Local1)), Local2, Index (Local0, Local1
                    ))
                Divide (0x1A, 0x08, Local2, Local1)
                ShiftLeft (One, Local2, Local2)
                Or (DerefOf (Index (Local0, Local1)), Local2, Index (Local0, Local1
                    ))
                Divide (0x10, 0x08, Local2, Local1)
                ShiftLeft (One, Local2, Local2)
                Or (DerefOf (Index (Local0, Local1)), Local2, Index (Local0, Local1
                    ))
                Divide (0x1B, 0x08, Local2, Local1)
                ShiftLeft (One, Local2, Local2)
                Or (DerefOf (Index (Local0, Local1)), Local2, Index (Local0, Local1
                    ))
                Divide (0x05, 0x08, Local2, Local1)
                ShiftLeft (One, Local2, Local2)
                Or (DerefOf (Index (Local0, Local1)), Local2, Index (Local0, Local1
                    ))
                Divide (0x06, 0x08, Local2, Local1)
                ShiftLeft (One, Local2, Local2)
                Or (DerefOf (Index (Local0, Local1)), Local2, Index (Local0, Local1
                    ))
                Return (Local0)
            }
            Else
            {
                If (LEqual (_T_0, 0x1A))
                {
                    CreateField (Arg3, 0x18, 0x02, OPCE)
                    CreateField (Arg3, Zero, One, FLCH)
                    If (ToInteger (FLCH))
                    {
                        Store (OPCE, OMPR)
                    }

                    Store (Buffer (0x04)
                        {
                            0x00, 0x00, 0x00, 0x00
                        }, Local0)
                    CreateField (Local0, Zero, One, OPEN)
                    CreateField (Local0, 0x03, 0x02, CGCS)
                    CreateField (Local0, 0x06, One, SHPC)
                    CreateField (Local0, 0x18, 0x03, DGPC)
                    CreateField (Local0, 0x1B, 0x02, HDAC)
                    Store (One, OPEN)
                    Store (One, SHPC)
                    Store (0x02, HDAC)
                    Store (One, DGPC)
                    If (\_SB.PCI0.PEG0.PEGP._STA ())
                    {
                        Store (0x03, CGCS)
                    }

                    Return (Local0)
                }
                Else
                {
                    If (LEqual (_T_0, 0x1B))
                    {
                        Store (Arg3, Local0)
                        CreateField (Local0, Zero, One, OPFL)
                        CreateField (Local0, One, One, OPVL)
                        If (ToInteger (OPVL))
                        {
                            Store (Zero, \_SB.PCI0.OPTF)
                            If (ToInteger (OPFL))
                            {
                                Store (One, \_SB.PCI0.OPTF)
                            }
                        }

                        Store (\_SB.PCI0.OPTF, Local0)
                        Return (Local0)
                    }
                    Else
                    {
                        If (LEqual (_T_0, 0x10))
                        {
                            P8XH (Zero, 0x10)
                            Return (\_SB.PCI0.PEG0.PEGP.GOBT (Arg3))
                        }
                    }
                }
            }

            Return (0x80000002)
        }
    }

    Scope (\_SB.PCI0.PEG0.PEGP)
    {
        Name (DGOS, Zero)
        OperationRegion (PCNV, PCI_Config, 0x0488, 0x04)
        Field (PCNV, AnyAcc, NoLock, Preserve)
        {
                ,   25, 
            MLTF,   1
        }

        OperationRegion (ECRM, SystemMemory, 0xFF808201, 0x0100)
        Field (ECRM, ByteAcc, NoLock, Preserve)
        {
                    Offset (0x4E), 
                ,   4, 
            VGEN,   1
        }

        Method (_PS0, 0, NotSerialized)
        {
            If (DGOS)
            {
                \_SB.PCI0.PEG0.PEGP._ON ()
                Store (Zero, DGOS)
                Store (Zero, MLTF)
                Store (One, VGEN)
            }
        }

        Method (_PS3, 0, NotSerialized)
        {
            If (LEqual (\_SB.PCI0.PEG0.PEGP.OMPR, 0x03))
            {
                \_SB.PCI0.PEG0.PEGP._OFF ()
                Store (One, DGOS)
                Store (0x02, \_SB.PCI0.PEG0.PEGP.OMPR)
                Store (Zero, VGEN)
            }
        }

        Method (_STA, 0, NotSerialized)
        {
            Return (0x0F)
        }
    }

    Scope (\)
    {
        Method (CMPB, 2, NotSerialized)
        {
            Store (SizeOf (Arg0), Local1)
            If (LNotEqual (Local1, SizeOf (Arg1)))
            {
                Return (Zero)
            }

            Store (Zero, Local0)
            While (LLess (Local0, Local1))
            {
                If (LNotEqual (DerefOf (Index (Arg0, Local0)), DerefOf (Index (
                    Arg1, Local0))))
                {
                    Return (Zero)
                }

                Increment (Local0)
            }

            Return (One)
        }
    }

    Scope (\_SB.PCI0.PEG0.PEGP)
    {
        Method (_DSM, 4, NotSerialized)
        {
            Store ("----- DGPU _DSM --------", Debug)
            If (LEqual (Arg0, Buffer (0x10)
                    {
                        /* 0000 */    0xF8, 0xD8, 0x86, 0xA4, 0xDA, 0x0B, 0x1B, 0x47, 
                        /* 0008 */    0xA7, 0x2B, 0x60, 0x42, 0xA6, 0xB5, 0xBE, 0xE0
                    }))
            {
                Return (\_SB.PCI0.PEG0.PEGP.NVOP (Arg0, Arg1, Arg2, Arg3))
            }

            Return (0x80000001)
        }
    }
}

